import os
from some_func import exp2args, exp2args_new, addArgs, exp2args_MDMM
import glob

cuda = 0
expname = 'geonerfMDMM_ver0'
args = exp2args_new(expname)
expname += '-adain_content_level'
args += exp2args_MDMM(expname)
expname += '_styleTwoBranch'
expname += '-mse'
expname += '-woMSE1'

expname += '-zInputStyle'
expname += '_isInput'
expname += '-delta_t_1x1'
expname += '-t0Rec'

expname += '-sunnyNight'
expname += '-styleWaymo'

args += addArgs(expname)

##### train
# cmd = f'CUDA_VISIBLE_DEVICES={cuda} python run_geo_nerf.py --config ./configs/config_general.txt --batch_size 1024 ' \
#       f'{args} --only_ithaca --nb_views 2 --ithaca_use_two_cams --chunk 2048 ' \
#       f'--expname {expname} ' \

# print(cmd)
# os.system(cmd)

##### test
## ithaca
for src_specify, ref_specify in [('sunny','sunny'),('night','sunny'),('rain','sunny'),('snow','sunny')]:
      expname_test = f'val_all/{expname}/nb_2-phi-{src_specify}'
      ckpts_all = glob.glob(f'./logs/train_new/{expname}/ckpts/*.ckpt')
      ckpts_all.sort()
      ckpt = ckpts_all[-1]

      cmd = f'CUDA_VISIBLE_DEVICES={cuda} python run_geo_nerf.py --config ./configs/config_ithaca.txt --eval ' \
            f'{args} --src_specify {src_specify} --ref_specify {ref_specify} --only_ithaca --nb_views 2 --ithaca_use_two_cams --chunk 2048 ' \
            f'--expname {expname_test} --ckpt {ckpt} ' \
            f'--input_phi_to_test '
      
      print(cmd)
      os.system(cmd)
